window.Gleam.initSearch([{"doc":"trust","title":"trust","content":"# trust\n\nData validation library for Gleam\n\n&gt; :construction: Work in progress. Any changes may come.\n\nBuilds upon the foundation of `gleam/dynamic` and adds useful helpers.\n\n[![Package Version](https://img.shields.io/hexpm/v/trust)](https://hex.pm/packages/trust)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/trust/)\n\n","url":"index.html"},{"doc":"trust","title":"DecodeError","content":"pub type DecodeError {\n  DecodeError(\n    message: String,\n    path: List(String),\n    error_kind: DecodeErrorKind,\n  )\n}\n\nDecodeError(\n  message: String,\n  path: List(String),\n  error_kind: DecodeErrorKind,\n)\n\n\nSynonyms:\ntrust.DecodeError\ntrust DecodeError","url":"trust.html#DecodeError"},{"doc":"trust","title":"DecodeErrorKind","content":"pub type DecodeErrorKind {\n  TypeMismatch(expected: String, found: String)\n  IntMinError(min: Int, actual: Int)\n  IntMaxError(max: Int, actual: Int)\n  FieldNotFound\n  NotInStringEnum(available_keys: List(String), found: String)\n  StringLenError(expected_length: Int, actual_length: Int)\n  StringMinLenError(min_length: Int, actual_length: Int)\n  StringMaxLenError(max_length: Int, actual_length: Int)\n  TupleNegativeIndex(index: Int)\n  TupleTooSmall(required_size: Int, actual_size: Int)\n}\n\nTypeMismatch(expected: String, found: String)\n\n\nIntMinError(min: Int, actual: Int)\n\n\nIntMaxError(max: Int, actual: Int)\n\n\nFieldNotFound\n\n\nNotInStringEnum(available_keys: List(String), found: String)\n\n\nStringLenError(expected_length: Int, actual_length: Int)\n\n\nStringMinLenError(min_length: Int, actual_length: Int)\n\n\nStringMaxLenError(max_length: Int, actual_length: Int)\n\n\nTupleNegativeIndex(index: Int)\n\n\nTupleTooSmall(required_size: Int, actual_size: Int)\n\n\nSynonyms:\ntrust.DecodeErrorKind\ntrust DecodeErrorKind","url":"trust.html#DecodeErrorKind"},{"doc":"trust","title":"DecodeResult","content":"pub type DecodeResult(t) =\n  Result(t, List(DecodeError))\n\n\nSynonyms:\ntrust.DecodeResult\ntrust DecodeResult","url":"trust.html#DecodeResult"},{"doc":"trust","title":"Decoder","content":"pub type Decoder(t) =\n  fn(dynamic.Dynamic) -&gt; DecodeResult(t)\n\n\nSynonyms:\ntrust.Decoder\ntrust Decoder","url":"trust.html#Decoder"},{"doc":"trust","title":"bool","content":"pub fn bool(data: Dynamic) -&gt; Result(Bool, List(DecodeError))\n\nSynonyms:\ntrust.bool\ntrust bool","url":"trust.html#bool"},{"doc":"trust","title":"bool_literal","content":"pub fn bool_literal(\n  value: Bool,\n) -&gt; fn(Dynamic) -&gt; Result(Bool, List(DecodeError))\n\nSynonyms:\ntrust.bool_literal\ntrust bool_literal","url":"trust.html#bool_literal"},{"doc":"trust","title":"bool_literal_with_message","content":"pub fn bool_literal_with_message(\n  value: Bool,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(Bool, List(DecodeError))\n\nSynonyms:\ntrust.bool_literal_with_message\ntrust bool_literal_with_message","url":"trust.html#bool_literal_with_message"},{"doc":"trust","title":"bool_with_message","content":"pub fn bool_with_message(\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(Bool, List(DecodeError))\n\nSynonyms:\ntrust.bool_with_message\ntrust bool_with_message","url":"trust.html#bool_with_message"},{"doc":"trust","title":"decode1","content":"pub fn decode1(\n  constructor: fn(a) -&gt; b,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(b, List(DecodeError))\n\nSynonyms:\ntrust.decode1\ntrust decode1","url":"trust.html#decode1"},{"doc":"trust","title":"decode2","content":"pub fn decode2(\n  constructor: fn(a, b) -&gt; c,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(c, List(DecodeError))\n\nSynonyms:\ntrust.decode2\ntrust decode2","url":"trust.html#decode2"},{"doc":"trust","title":"decode3","content":"pub fn decode3(\n  constructor: fn(a, b, c) -&gt; d,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  t3: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(d, List(DecodeError))\n\nSynonyms:\ntrust.decode3\ntrust decode3","url":"trust.html#decode3"},{"doc":"trust","title":"decode4","content":"pub fn decode4(\n  constructor: fn(a, b, c, d) -&gt; e,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  t3: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  t4: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(e, List(DecodeError))\n\nSynonyms:\ntrust.decode4\ntrust decode4","url":"trust.html#decode4"},{"doc":"trust","title":"decode5","content":"pub fn decode5(\n  constructor: fn(a, b, c, d, e) -&gt; f,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  t3: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  t4: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  t5: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(f, List(DecodeError))\n\nSynonyms:\ntrust.decode5\ntrust decode5","url":"trust.html#decode5"},{"doc":"trust","title":"decode6","content":"pub fn decode6(\n  constructor: fn(a, b, c, d, e, f) -&gt; g,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  t3: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  t4: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  t5: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n  t6: fn(Dynamic) -&gt; Result(f, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(g, List(DecodeError))\n\nSynonyms:\ntrust.decode6\ntrust decode6","url":"trust.html#decode6"},{"doc":"trust","title":"decode7","content":"pub fn decode7(\n  constructor: fn(a, b, c, d, e, f, g) -&gt; h,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  t3: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  t4: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  t5: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n  t6: fn(Dynamic) -&gt; Result(f, List(DecodeError)),\n  t7: fn(Dynamic) -&gt; Result(g, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(h, List(DecodeError))\n\nSynonyms:\ntrust.decode7\ntrust decode7","url":"trust.html#decode7"},{"doc":"trust","title":"decode8","content":"pub fn decode8(\n  constructor: fn(a, b, c, d, e, f, g, h) -&gt; i,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  t3: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  t4: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  t5: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n  t6: fn(Dynamic) -&gt; Result(f, List(DecodeError)),\n  t7: fn(Dynamic) -&gt; Result(g, List(DecodeError)),\n  t8: fn(Dynamic) -&gt; Result(h, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(i, List(DecodeError))\n\nSynonyms:\ntrust.decode8\ntrust decode8","url":"trust.html#decode8"},{"doc":"trust","title":"decode9","content":"pub fn decode9(\n  constructor: fn(a, b, c, d, e, f, g, h, i) -&gt; j,\n  t1: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  t2: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  t3: fn(Dynamic) -&gt; Result(c, List(DecodeError)),\n  t4: fn(Dynamic) -&gt; Result(d, List(DecodeError)),\n  t5: fn(Dynamic) -&gt; Result(e, List(DecodeError)),\n  t6: fn(Dynamic) -&gt; Result(f, List(DecodeError)),\n  t7: fn(Dynamic) -&gt; Result(g, List(DecodeError)),\n  t8: fn(Dynamic) -&gt; Result(h, List(DecodeError)),\n  t9: fn(Dynamic) -&gt; Result(i, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(j, List(DecodeError))\n\nSynonyms:\ntrust.decode9\ntrust decode9","url":"trust.html#decode9"},{"doc":"trust","title":"dict","content":"pub fn dict(\n  key_decoder: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  value_decoder: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(Dict(a, b), List(DecodeError))\n\nSynonyms:\ntrust.dict\ntrust dict","url":"trust.html#dict"},{"doc":"trust","title":"dynamic","content":"pub fn dynamic(\n  value: Dynamic,\n) -&gt; Result(Dynamic, List(DecodeError))\n\nSynonyms:\ntrust.dynamic\ntrust dynamic","url":"trust.html#dynamic"},{"doc":"trust","title":"element","content":"pub fn element(\n  index: Int,\n  inner_decoder: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(a, List(DecodeError))\n\nSynonyms:\ntrust.element\ntrust element","url":"trust.html#element"},{"doc":"trust","title":"element_with_message","content":"pub fn element_with_message(\n  index: Int,\n  inner_decoder: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(a, List(DecodeError))\n\nSynonyms:\ntrust.element_with_message\ntrust element_with_message","url":"trust.html#element_with_message"},{"doc":"trust","title":"field","content":"pub fn field(\n  name: String,\n  inner_decoder: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; fn(Dynamic) -&gt; Result(a, List(DecodeError))\n\nSynonyms:\ntrust.field\ntrust field","url":"trust.html#field"},{"doc":"trust","title":"int","content":"pub fn int(data: Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int\ntrust int","url":"trust.html#int"},{"doc":"trust","title":"int_literal","content":"pub fn int_literal(\n  value: Int,\n) -&gt; fn(Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int_literal\ntrust int_literal","url":"trust.html#int_literal"},{"doc":"trust","title":"int_literal_with_message","content":"pub fn int_literal_with_message(\n  value: Int,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int_literal_with_message\ntrust int_literal_with_message","url":"trust.html#int_literal_with_message"},{"doc":"trust","title":"int_max","content":"pub fn int_max(\n  source: fn(Dynamic) -&gt; Result(Int, List(DecodeError)),\n  max: Int,\n) -&gt; fn(Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int_max\ntrust int_max","url":"trust.html#int_max"},{"doc":"trust","title":"int_max_with_message","content":"pub fn int_max_with_message(\n  source: fn(Dynamic) -&gt; Result(Int, List(DecodeError)),\n  max: Int,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int_max_with_message\ntrust int_max_with_message","url":"trust.html#int_max_with_message"},{"doc":"trust","title":"int_min","content":"pub fn int_min(\n  source: fn(Dynamic) -&gt; Result(Int, List(DecodeError)),\n  min: Int,\n) -&gt; fn(Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int_min\ntrust int_min","url":"trust.html#int_min"},{"doc":"trust","title":"int_min_with_message","content":"pub fn int_min_with_message(\n  source: fn(Dynamic) -&gt; Result(Int, List(DecodeError)),\n  min: Int,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int_min_with_message\ntrust int_min_with_message","url":"trust.html#int_min_with_message"},{"doc":"trust","title":"int_with_message","content":"pub fn int_with_message(\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(Int, List(DecodeError))\n\nSynonyms:\ntrust.int_with_message\ntrust int_with_message","url":"trust.html#int_with_message"},{"doc":"trust","title":"map","content":"pub fn map(\n  source: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  mapper: fn(a) -&gt; b,\n) -&gt; fn(Dynamic) -&gt; Result(b, List(DecodeError))\n\nSynonyms:\ntrust.map\ntrust map","url":"trust.html#map"},{"doc":"trust","title":"replace","content":"pub fn replace(\n  source: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  replace_value: b,\n) -&gt; fn(Dynamic) -&gt; Result(b, List(DecodeError))\n\nSynonyms:\ntrust.replace\ntrust replace","url":"trust.html#replace"},{"doc":"trust","title":"string","content":"pub fn string(data: Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string\ntrust string","url":"trust.html#string"},{"doc":"trust","title":"string_enum","content":"pub fn string_enum(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  definition: List(#(String, a)),\n) -&gt; fn(Dynamic) -&gt; Result(a, List(DecodeError))\n\nSynonyms:\ntrust.string_enum\ntrust string_enum","url":"trust.html#string_enum"},{"doc":"trust","title":"string_enum_with_message","content":"pub fn string_enum_with_message(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  definition: List(#(String, a)),\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(a, List(DecodeError))\n\nSynonyms:\ntrust.string_enum_with_message\ntrust string_enum_with_message","url":"trust.html#string_enum_with_message"},{"doc":"trust","title":"string_len","content":"pub fn string_len(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  len: Int,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_len\ntrust string_len","url":"trust.html#string_len"},{"doc":"trust","title":"string_len_with_message","content":"pub fn string_len_with_message(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  len: Int,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_len_with_message\ntrust string_len_with_message","url":"trust.html#string_len_with_message"},{"doc":"trust","title":"string_literal","content":"pub fn string_literal(\n  value: String,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_literal\ntrust string_literal","url":"trust.html#string_literal"},{"doc":"trust","title":"string_literal_with_message","content":"pub fn string_literal_with_message(\n  value: String,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_literal_with_message\ntrust string_literal_with_message","url":"trust.html#string_literal_with_message"},{"doc":"trust","title":"string_max_len","content":"pub fn string_max_len(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  max_len: Int,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_max_len\ntrust string_max_len","url":"trust.html#string_max_len"},{"doc":"trust","title":"string_max_len_with_message","content":"pub fn string_max_len_with_message(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  max_len: Int,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_max_len_with_message\ntrust string_max_len_with_message","url":"trust.html#string_max_len_with_message"},{"doc":"trust","title":"string_min_len","content":"pub fn string_min_len(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  min_len: Int,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_min_len\ntrust string_min_len","url":"trust.html#string_min_len"},{"doc":"trust","title":"string_min_len_with_message","content":"pub fn string_min_len_with_message(\n  source: fn(Dynamic) -&gt; Result(String, List(DecodeError)),\n  min_len: Int,\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_min_len_with_message\ntrust string_min_len_with_message","url":"trust.html#string_min_len_with_message"},{"doc":"trust","title":"string_with_message","content":"pub fn string_with_message(\n  message: String,\n) -&gt; fn(Dynamic) -&gt; Result(String, List(DecodeError))\n\nSynonyms:\ntrust.string_with_message\ntrust string_with_message","url":"trust.html#string_with_message"},{"doc":"trust","title":"trust","content":"","url":"trust.html"}]);